import javax.imageio.*;
import java.io.IOException;
import java.io.File;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;
import java.awt.Color;


public class Tramage {
	/**
	 * Renvoie la couleur (noir ou blanc) la plus proche de la couleur donnee (niveau de gris)
	 * @param couleur niveau de gris
	 * @return noir (0) si c'est un gris fonce, blanc (255) si c'est un gris clair
	 */
	public static int seuillage(int couleur) {
		return 0;// A completer
	}
	/**
	 * Convertit en noir et blanc une image en niveaux de gris.
	 * Algorithme naif (remplace les gris clairs par du blanc,
	 * les gris fonces par du noir).
	 * @param tabGris tableau de niveaux de gris entre 0 et 255
	 * @param tableau de noir (0) et blanc (255)
	 */
	public static int[][] seuillage(int[][] tabGris) {
		return null;// A completer
	}
	/**
	 * Convertit en noir et blanc une image en niveaux de gris.
	 * Algorithme de tramage de Floyd-Steinberg. Remplace les gris clairs par du blanc,
	 * les gris fonces par du noir, et diffuse l'erreur faite a chaque pixel aux voisins.
	 * @param tabGris tableau de niveaux de gris entre 0 et 255
	 * @param tableau de noir (0) et blanc (255)
	 */
	public static int[][] tramage(int[][] tabGris) {
		return null;// A completer
	}

	/**
	 * Cree un tableau contenant les couleurs des pixels d'une image
	 * @param nomFichier nom du fichier image a lire
	 * @return tableau contenant les couleurs, en niveau de gris,
	 * de l'image passee en parametre (0=noir, 255=blanc)
	 */	
	public static int[][] creeTableau(String nomFichier) {
		try {
			int i, j;
			int[][] res;

			// Creation d'une BufferedImage correspondant au fichier
			BufferedImage img = ImageIO.read(new File(nomFichier));
			// Conversion en niveaux de gris
			BufferedImage gray = new BufferedImage(img.getWidth(), img.getHeight(), BufferedImage.TYPE_BYTE_GRAY);
            Graphics2D g = gray.createGraphics();
			g.setColor(Color.WHITE);
			g.fillRect(0, 0, gray.getWidth(), gray.getHeight());
            g.drawImage(img, 0, 0, null);

			// Creation et remplissage du tableau stockant les valeurs des pixels
			res = new int[gray.getHeight()][gray.getWidth()];
			for(i=0; i<gray.getHeight(); i++)
				for(j=0; j<gray.getWidth(); j++)
					res[i][j] = gray.getRGB(j, i)&255;
			return res;
		} catch	(IOException e) {
			System.out.println("Probleme de lecture du fichier");
			return null;
		}
	}
	/**
	 * Sauvegarde un tableau de niveaux de gris sous forme d'image png
	 * @param tabGris tableau contenant les niveaux de gris
	 * @param nomFichier nom du fichier image a sauvegarder
	 */	
	public static void sauveImage(int[][] tabGris, String nomFichier) {
		try {
    		BufferedImage img = new BufferedImage(tabGris[0].length, tabGris.length, BufferedImage.TYPE_INT_RGB);
			int i, j;
			for(i=0; i<img.getHeight(); i++)
				for(j=0; j<img.getWidth(); j++)
					img.setRGB(j, i, gris(tabGris[i][j]));

    		File outputfile = new File(nomFichier+".png");
    		ImageIO.write(img, "png", outputfile);
		} catch (IOException e) {
    		System.out.println("Probleme d'ecriture du fichier");	
		}
	}
	static int gris(int c) {
		return (c<<16)+(c<<8)+c;
	}

	public static void main(String[] args) {
		String nom = "charlemagne";
		int[][] t = creeTableau(nom + ".jpg");
		sauveImage(seuillage(t), nom + "_seuillage");
		sauveImage(tramage(t), nom + "_tramage");
	}
}
